"use strict";
exports.__esModule = true;
var http = require("http");
var CouchProxy = (function () {
    function CouchProxy(appHandler) {
        var _this = this;
        this.appHandler = appHandler;
        this.appHandler.log("Pub SSL Server listening on port 9120");
        var http2 = http.createServer().listen(9120);
        http2.on("request", function (req, res) {
            _this.handelData(req, res, req.method);
        });
    }
    CouchProxy.prototype.handelData = function (req, res, methode) {
        var _this = this;
        var urlData = req.url.split("/");
        this.checkKey(urlData[1], function (r) {
            if (r) {
                var newUrl = "/" + r + "_" + urlData[2];
                for (var i = 3, im = urlData.length; i < im; i++) {
                    newUrl += "/" + urlData[i];
                }
                _this.handleRequest(req, res, newUrl);
            }
            else {
                res.statusCode = 404;
                res.end();
            }
        });
    };
    CouchProxy.prototype.checkKey = function (key, cb) {
        var _this = this;
        if (this.lastKey === key) {
            cb(this.lastDB);
        }
        else {
            this.appHandler.doJson("http://127.0.0.1/rest/dikas/lizenz/dbsync/" + encodeURI(key), function (res) {
                if (res && res.Message) {
                    _this.lastKey = key;
                    _this.lastDB = res.Message;
                    cb(_this.lastDB);
                }
                else {
                    _this.appHandler.log("CouchProxy: Key not Matiching " + key);
                    cb(null);
                }
            });
        }
    };
    CouchProxy.prototype.handleRequest = function (req, res, urlpart) {
        var _this = this;
        req.pause();
        delete req.headers["host"];
        var options = {
            method: req.method,
            hostname: "127.0.0.1",
            port: 5984,
            path: urlpart,
            headers: req.headers,
            agent: false
        };
        var newReq = http.request(options, function (serverResponse) {
            serverResponse.pause();
            serverResponse.headers["Content-Type"] = serverResponse.headers["content-type"];
            delete serverResponse.headers["content-type"];
            delete serverResponse.headers["transfer-encoding"];
            delete serverResponse.headers["server"];
            res.writeHeader(serverResponse.statusCode, serverResponse.headers);
            serverResponse.pipe(res, { end: true });
            serverResponse.resume();
        });
        newReq.on("error", function (err) {
            _this.appHandler.logError(err.message + err.stack);
            res.statusCode = 404;
            res.end();
        });
        req.pipe(newReq, { end: true });
        req.resume();
    };
    return CouchProxy;
}());
exports.CouchProxy = CouchProxy;
//# sourceMappingURL=CouchProxy.js.map