"use strict";
exports.__esModule = true;
var OpenBon_1 = require("./../model/OpenBon");
var BonAddress_1 = require("./../model/BonAddress");
var NewPayBon_1 = require("./../model/NewPayBon");
var net = require("net");
var ComBonHandler = (function () {
    function ComBonHandler(appHandler) {
        this.appHandler = appHandler;
    }
    ComBonHandler.prototype.startCOMServer = function () {
        var _this = this;
        this.tcpServer = net.createServer(function (srv) {
            var curElm = [];
            var serverData = "";
            srv.on("end", function () {
                _this.parseBon(serverData);
            });
            srv.on("data", function (data) {
                serverData += data.toString();
            });
        });
    };
    ComBonHandler.prototype.getMitarbeiter = function (pb, line) {
        pb.PersonalId = "persvt" + line[1];
        pb.PersonalName = line[2] + " " + line[3];
    };
    ComBonHandler.prototype.getKunde = function (pb, line) {
        pb.CustomerId = "custvt" + line[1];
        pb.Address = new BonAddress_1.BonAddress();
        pb.Address.Firstname = line[2];
        pb.Address.Lastname = line[3];
    };
    ComBonHandler.prototype.getArtikel = function (ob, line) {
        ob.ArticleId = "artvt" + line.shift();
        ob.ArticleName = line.join(" ");
    };
    ComBonHandler.prototype.getArtikelPreis = function (ob, line) {
        ob.Count = 1;
        ob.Price = this.parseString(line.pop());
        ob.ExtraDescription = line.join(" ");
    };
    ComBonHandler.prototype.getGesamt = function (pb, line) {
        pb.PayValue = this.parseString(line.pop());
    };
    ComBonHandler.prototype.parseString = function (s) {
        return parseFloat(s.replace(",", "."));
    };
    ComBonHandler.prototype.parseBon = function (s) {
        var _this = this;
        var pb = new NewPayBon_1.NewPayBon();
        pb.NewPayBons = [];
        s = s.replace("\r\n", "\n");
        var lines = s.split("\n");
        var canArticle = false;
        var isArtPrice = false;
        var openBon;
        lines.forEach(function (l) {
            var names = l.trim().split(" ").filter(function (d) { return d.length > 0; });
            switch (names[0]) {
                case "Mitarbeiter:":
                    _this.getMitarbeiter(pb, names);
                    break;
                case "Kunde:":
                    _this.getKunde(pb, names);
                    canArticle = true;
                    break;
                case "-----":
                case "EUR":
                    break;
                case "Endbetrag:":
                    canArticle = false;
                    _this.getGesamt(pb, names);
                    break;
                default:
                    if (names.length > 0 && names[0].length > 0) {
                        if (canArticle) {
                            if (isArtPrice) {
                                _this.getArtikelPreis(openBon, names);
                                pb.NewPayBons.push(openBon);
                            }
                            else {
                                openBon = new OpenBon_1.OpenBon();
                                _this.getArtikel(openBon, names);
                            }
                            isArtPrice = !isArtPrice;
                        }
                        else {
                            if (names.length > 4 && names[4] === "BN") {
                                pb.Comment = l.trim();
                            }
                        }
                    }
                    break;
            }
        });
        return pb;
    };
    return ComBonHandler;
}());
exports.ComBonHandler = ComBonHandler;
//# sourceMappingURL=ComBonHandler.js.map