"use strict";
exports.__esModule = true;
var ComBonHandler_1 = require("./ComBonHandler");
var fs = require("fs");
var ComBonHandlerTest = (function () {
    function ComBonHandlerTest() {
        this.tools = new ComBonHandler_1.ComBonHandler(null);
    }
    ComBonHandlerTest.prototype.logHelper = function (msg) {
        console.log("           " + msg);
    };
    ComBonHandlerTest.prototype.testVideoTaxiBon = function (done) {
        var data = fs.readFileSync("C:\\test\\video_bon.txt").toString();
        var pb = this.tools.parseBon(data);
        if (pb.PayValue !== 3) {
            throw new Error("PayValue no match " + pb.PayValue);
        }
        if (pb.PersonalId !== "persvt1") {
            throw new Error("Personal ID  no match " + pb.PersonalId);
        }
        if (pb.PersonalName !== "Steffi Steinreich") {
            throw new Error("Personal Name  no match " + pb.PersonalName);
        }
        if (pb.CustomerId !== "custvt2") {
            throw new Error("Customer ID no match " + pb.CustomerId);
        }
        if (!pb.Address) {
            throw new Error("No Customer  Address ");
        }
        if (pb.Address.Firstname !== "Christine") {
            throw new Error("Firstname Name no match " + pb.Address.Firstname);
        }
        if (pb.Address.Lastname !== "Mustermann") {
            throw new Error("Firstname Name no match " + pb.Address.Lastname);
        }
        if (!pb.NewPayBons || pb.NewPayBons.length < 1) {
            throw new Error("No Positions ");
        }
        var b1 = pb.NewPayBons[0];
        if (b1.ArticleName !== "(T)Raumschiff Surprise Periode 1") {
            throw new Error("Article Name not right " + b1.ArticleName);
        }
        if (b1.ArticleId !== "artvt602") {
            throw new Error("Article Id not right " + b1.ArticleId);
        }
        if (b1.Count !== 1) {
            throw new Error("Article Count not right " + b1.Count);
        }
        if (b1.Price !== 3) {
            throw new Error("Article Count not right " + b1.Price);
        }
        if (!pb.Comment || pb.Comment.length === 0) {
            throw new Error("Source Info Missing " + pb.Comment);
        }
        return pb;
    };
    return ComBonHandlerTest;
}());
exports.ComBonHandlerTest = ComBonHandlerTest;
//# sourceMappingURL=ComBonHandler.test.js.map