"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var SchankStatus_1 = require("./model/SchankStatus");
var BaseSchankanlage_1 = require("./BaseSchankanlage");
var Addimat = (function (_super) {
    __extends(Addimat, _super);
    function Addimat() {
        var _this = _super.call(this) || this;
        _this.$STX = 2;
        _this.$ETX = 3;
        _this.$ENQ = 5;
        _this.$ACK = 6;
        _this.$NAK = 15;
        _this.checkDate = new Date();
        _this.checkCountOk = 0;
        _this.checkCountError = 0;
        _this.Name = "Addimat";
        return _this;
    }
    Addimat.prototype.handleResponse = function (s) {
        var n;
        for (var i = 0, im = s.length; i < im; i++) {
            n = s[i];
            if (n === this.$ETX || n === this.$ACK || n === this.$NAK) {
                return true;
            }
        }
        return false;
    };
    Addimat.prototype.getUmsatzData = function (cb) {
        var _this = this;
        this.app.verbose("Check new Bookings...");
        if (this.checkDate < new Date() || this.checkCountOk > 99 || this.checkCountError > 9) {
            this.checkDate = new Date(new Date().getTime() + 5 * 60000);
            this.app.log("Checks " + this.checkCountOk + " Ok  " + this.checkCountError + " Error");
            this.checkCountOk = this.checkCountError = 0;
        }
        var cmd = this.formatCommand("K");
        this.portHandler.sendData([this.$ENQ], function (resp) {
            var haveBooking = false;
            if (resp) {
                if (resp[0] === _this.$ACK) {
                    _this.portHandler.sendData(cmd, function (res2) {
                        if (res2) {
                            _this.checkCountOk++;
                            var ax = res2.toString();
                            switch (res2[0]) {
                                case _this.$STX:
                                    haveBooking = true;
                                    _this.handleNewData(res2);
                                    break;
                                case _this.$ACK:
                                    break;
                                case _this.$NAK:
                                    _this.app.verbose("NAK");
                                    break;
                                default:
                                    _this.app.verbose("Error Unkown (" + ax + ")");
                                    break;
                            }
                        }
                        cb(haveBooking);
                    });
                }
                else {
                    _this.checkCountError++;
                    _this.app.logError("Error ACK missing");
                    cb(haveBooking);
                }
            }
            else {
                cb(haveBooking);
            }
        });
    };
    Addimat.prototype.sendUmsatz = function (booking, cb) {
        var _this = this;
        var addmin = "+";
        if (booking.Count < 1) {
            booking.Count = booking.Count * -1;
            addmin = "-";
        }
        var scmd = "/" + this.formatNr(booking.Kellner, 3)
            + this.formatNr(booking.PLU, 5) + addmin + this.formatNr(booking.Count, 5);
        this.app.verbose("Send CMD " + scmd);
        var cmd = this.formatCommand(scmd);
        this.portHandler.sendData([this.$ENQ], function (resp) {
            if (resp) {
                if (resp[0] === _this.$ACK) {
                    _this.app.verbose("Send Booking " + scmd);
                    _this.portHandler.sendData(cmd, function (res2) {
                        if (res2) {
                            switch (res2[0]) {
                                case _this.$ACK:
                                    _this.app.verbose("Booking (OK)");
                                    _this.app.Status.FromServer++;
                                    booking.$IsDone = true;
                                    break;
                                case _this.$NAK:
                                    _this.app.Status.FromServerError++;
                                    _this.app.verbose("Booking (NAK)");
                                    break;
                                default:
                                    _this.app.verbose("Booking  NotOK ??(" + res2 + ")");
                                    break;
                            }
                        }
                        cb(booking.$IsDone);
                    });
                }
                else {
                    _this.app.verbose("Error No ACK after ENQ (" + resp + ")");
                    cb(false);
                }
            }
            else {
                _this.app.verbose("Error no Response");
                cb(false);
            }
        });
    };
    Addimat.prototype.calccrc = function (s) {
        var d = 0;
        var c;
        for (var i = 0, im = s.length; i < im; i++) {
            c = s.charCodeAt(i);
            d = d ^ c;
        }
        return d;
    };
    Addimat.prototype.formatCommand = function (s) {
        var d = 0;
        var b = [2];
        var c;
        for (var i = 0, im = s.length; i < im; i++) {
            c = s.charCodeAt(i);
            b.push(c);
            d = d ^ c;
        }
        b.push(3);
        d = d ^ 3;
        b.push(d);
        return b;
    };
    Addimat.prototype.handleNewData = function (buf) {
        var s = new Buffer(buf).toString();
        var s2 = s.substr(1, s.length - 2);
        var t = new SchankStatus_1.PLUBooking();
        t.Kellner = parseInt(s.substr(1, 3));
        t.Tisch = parseInt(s.substr(4, 5));
        t.PLU = parseInt(s.substr(9, 5));
        t.Count = parseInt(s.substr(14, 5));
        s2 = s.substr(19, 1);
        if (s2 === "-") {
            t.Count = t.Count * -1;
        }
        this.app.SrvHandler.handleData(t);
        this.portHandler.sendData([this.$ACK], null);
    };
    return Addimat;
}(BaseSchankanlage_1.BaseSchankanlage));
exports.Addimat = Addimat;
//# sourceMappingURL=Addimat.js.map