"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var SchankStatus_1 = require("./model/SchankStatus");
var BaseSchankanlage_1 = require("./BaseSchankanlage");
var Hogatron = (function (_super) {
    __extends(Hogatron, _super);
    function Hogatron() {
        var _this = _super.call(this) || this;
        _this.Name = "Hogatron";
        return _this;
    }
    Hogatron.prototype.handleResponse = function (buf) {
        if (!this.app.Config.TableLength) {
            this.app.Config.TableLength = 3;
        }
        var s = new Buffer(buf).toString("ascii");
        var r = false;
        var count = this.app.Config.KellnerLength + this.app.Config.PLULength + this.app.Config.TableLength;
        if (this.lastCMD !== "E") {
            r = true;
            this.app.verbose("normal response" + count + " zu " + buf.length + " " + r);
        }
        else {
            r = buf.length >= count;
            this.app.verbose("check Response len " + count + " zu " + buf.length + " " + r);
        }
        return r;
    };
    Hogatron.prototype.translateNewBooking = function (elm) {
        var r = false;
        var posCount = 0;
        try {
            if (elm.length > this.app.Config.KellnerLength) {
                var t = new SchankStatus_1.PLUBooking();
                t.Tisch = 0;
                t.Count = 1;
                t.Kellner = 0;
                t.PLU = 0;
                var k = void 0;
                t.Kellner = parseInt(elm.substr(posCount, this.app.Config.KellnerLength));
                if (t.Kellner > 0) {
                    posCount += this.app.Config.KellnerLength;
                    t.Date = new Date();
                    t.PLU = parseInt(elm.substr(posCount, this.app.Config.PLULength));
                    posCount += this.app.Config.PLULength;
                    if (elm.length > posCount) {
                        k = elm.substr(posCount, this.app.Config.TableLength);
                        this.app.verbose("Info: Tisch " + "(" + posCount + ") Data:" + k);
                        if (k) {
                            t.Tisch = parseInt(k);
                            if (isNaN(t.Tisch)) {
                                t.Tisch = 0;
                            }
                        }
                    }
                    else {
                        this.app.verbose("Kein Tisch " + elm.length + "/" + posCount);
                    }
                    if (t.PLU > 0) {
                        this.app.SrvHandler.handleData(t);
                        r = true;
                    }
                    else {
                        this.app.logError("Error: Keine PLU in " + elm);
                    }
                }
                else {
                    this.app.verbose("Info: Leere Buchung (kein Kellner) " + elm);
                }
                this.app.verbose("accept booking: R");
                this.lastCMD = "R";
                this.portHandler.sendData("R", null);
            }
            else {
                this.app.verbose("Error: Buchung falsches Format " + elm);
            }
        }
        catch (e) {
            this.app.logError("Error translateNewBooking " + e);
        }
        return r;
    };
    Hogatron.prototype.sendUmsatz = function (booking, cb) {
        if (booking.PLU === -1) {
            this.app.log("Sende Schank Reset");
            this.lastCMD = "C";
            this.portHandler.sendData(new Buffer("C000", "ascii"), function (buf) {
            });
        }
        else {
            if (!this.app.Config.UseCount) {
                this.sendUmsatzSingle(booking, cb);
            }
            else {
                this.sendUmsatzCount(booking, cb);
            }
        }
    };
    Hogatron.prototype.sendUmsatzSingle = function (booking, cb) {
        var _this = this;
        if (!booking.$SendCount) {
            booking.$SendCount = 0;
        }
        this.sendUmsatzCount(booking, function (res) {
            if (res) {
                if (booking.Count > 0) {
                    booking.$SendCount++;
                }
                else {
                    booking.$SendCount--;
                }
                if (booking.$SendCount === booking.Count) {
                    cb(res);
                }
                else {
                    _this.sendUmsatzSingle(booking, cb);
                }
            }
            else {
                cb(res);
            }
        });
    };
    Hogatron.prototype.sendUmsatzCount = function (booking, cb) {
        var _this = this;
        var cmd;
        var isstrono = false;
        var targetCount = booking.Count;
        if (targetCount < 0) {
            targetCount = targetCount * -1;
            isstrono = true;
        }
        if (this.app.Config.Mode === 1 || this.app.Config.Mode === 2) {
            if (isstrono) {
                cmd = "S";
            }
            else {
                cmd = "K";
            }
            if (this.app.Config.Mode === 1 && this.app.Config.UseCount) {
                cmd += this.formatNr(targetCount, this.app.Config.CountLength)
                    + this.formatNr(booking.PLU, this.app.Config.PLULength);
            }
            else {
                cmd += this.formatNr(booking.PLU, this.app.Config.PLULength);
            }
        }
        else {
            if (isstrono) {
                cmd = "q";
            }
            else {
                cmd = "Q";
            }
            if (this.app.Config.UseCount) {
                cmd += this.formatNr(targetCount, this.app.Config.CountLength)
                    + this.formatNr(booking.Kellner, this.app.Config.KellnerLength)
                    + this.formatNr(booking.PLU, this.app.Config.PLULength);
            }
            else {
                cmd += this.formatNr(booking.Kellner, this.app.Config.KellnerLength)
                    + this.formatNr(booking.PLU, this.app.Config.PLULength);
            }
        }
        var buf = this.getSendText(cmd);
        this.app.verbose("send PLU:" + booking.PLU + " Kellner:" + booking.Kellner + " Anzahl:" + booking.Count + " -> " + cmd);
        if (!booking.$Error) {
            booking.$Error = 0;
        }
        this.lastCMD = cmd;
        this.portHandler.sendData(buf, function (buf) {
            var isOk = false;
            var resp = new Buffer(buf).toString("ascii");
            var rx = ({ IsOk: false });
            if (resp) {
                if (resp === "R" || (isstrono && resp === "f")) {
                    _this.app.log("OK P:" + booking.PLU + " K:" + booking.Kellner + " A:" + booking.Count + " -> " + resp);
                    _this.app.Status.FromServer++;
                    booking.$IsDone = true;
                    isOk = true;
                }
                else {
                    _this.app.logError("Error " + resp);
                    _this.app.Status.FromServerError++;
                    booking.$Error++;
                }
            }
            else {
                booking.$Error++;
                _this.app.logError("Error: Keine Antwort");
                _this.app.Status.FromServerError++;
            }
            if (booking.$Error > 10) {
                isOk = true;
                _this.app.logError("Error: entferne Buchung (" + booking.$Error + ")");
            }
            cb(isOk);
        });
    };
    Hogatron.prototype.getUmsatzData = function (cb) {
        var _this = this;
        this.app.verbose("Frage Buchungen von Schankanlage");
        this.lastCMD = "E";
        this.portHandler.sendData("E", function (buf) {
            var haveBooking = false;
            try {
                var resp = new Buffer(buf).toString("ascii");
                if (resp.length > 5) {
                    haveBooking = _this.translateNewBooking(resp);
                }
                else {
                    _this.app.verbose("leerer Umsatz" + resp);
                }
            }
            catch (e) {
                _this.app.logError("Error getUmsatz" + e);
            }
            cb(haveBooking);
        });
    };
    Hogatron.prototype.calcCheckSum = function (buffer, fillend) {
        var res = buffer[0];
        var len = buffer.length;
        if (fillend) {
            len--;
        }
        for (var i = 1; i < len; i++) {
            res = res ^ buffer[i];
        }
        if (fillend) {
            buffer[buffer.length - 1] = res;
        }
        return res;
    };
    Hogatron.prototype.getSendText = function (strdata) {
        var b;
        if (this.app.Config.CRCCheck) {
            b = new Buffer(strdata.length + 1);
            b.write(strdata, 0, strdata.length, "ascii");
            this.calcCheckSum(b, true);
        }
        else {
            b = new Buffer(strdata, "ascii");
        }
        return b;
    };
    Hogatron.prototype.testCheckSum = function () {
        var b = new Buffer(4);
        b[0] = 0x61;
        b[1] = 0x30;
        b[2] = 0x33;
        b[3] = 0x34;
        this.app.log("DATA " + b.toString("ascii"));
        var target = this.calcCheckSum(b);
        if (target !== 0x56) {
            this.app.log("XOR Check ist Fehlgeschlagen");
        }
        else {
            this.app.log("Prüfsummen Check war erfolgreich");
        }
        b = new Buffer("a034", "ascii");
        this.app.log("DATA " + b.toString("ascii"));
        target = this.calcCheckSum(b);
        if (target !== 0x56) {
            this.app.log("XOR Check ist Fehlgeschlagen");
        }
        else {
            this.app.log("Prüfsummen Check war erfolgreich");
        }
        b = this.getSendText("032047024");
        this.app.log("Test 3" + b.toString("ascii"));
    };
    return Hogatron;
}(BaseSchankanlage_1.BaseSchankanlage));
exports.Hogatron = Hogatron;
//# sourceMappingURL=Hogatron.js.map