"use strict";
var TcpPortHandler_1 = require("./TcpPortHandler");
var ComportHandler_1 = require("./ComportHandler");
var BaseSchankanlage = (function () {
    function BaseSchankanlage() {
        var _this = this;
        this.lastReset = new Date().getTime();
        this.Name = "BaseSchankanlage";
        this.OpenJobs = [];
        this.inUse = false;
        this.nextRunTimeout = setInterval(function () { return _this.runLoop(); }, 100);
        this.nextCheck = new Date(0);
    }
    BaseSchankanlage.prototype.formatNr = function (a, anz) {
        var ntext = a.toString();
        if (ntext.length < anz) {
            while (ntext.length < anz) {
                ntext = "0" + ntext;
            }
        }
        else if (ntext.length > anz) {
            ntext = ntext.substr(0, anz);
        }
        return ntext;
    };
    BaseSchankanlage.prototype.updatePortHandler = function () {
        var _this = this;
        if (this.portHandler) {
            this.portHandler.close();
            this.portHandler = null;
            setTimeout(function () {
                _this.initComport();
            }, 500);
        }
        else {
            this.initComport();
        }
    };
    BaseSchankanlage.prototype.addUmsatz = function (booking) {
        var _this = this;
        if (!this.app.Status.FromServerBookings) {
            this.app.Status.FromServerBookings = [];
        }
        this.app.Status.FromServerBookings = this.app.Status.FromServerBookings.concat(booking);
        if (this.app.Status.FromServerBookings.length > 10) {
            this.app.Status.FromServerBookings.splice(0, this.app.Status.FromServerBookings.length - 10);
        }
        booking = booking.filter(function (d) {
            return d.Count && d.Kellner && d.PLU;
        });
        if (booking.length > 0) {
            booking.forEach(function (d) {
                d.Date = new Date();
                _this.OpenJobs.push(d);
            });
        }
        this.app.Status.OpenFromServer = this.OpenJobs.length;
    };
    BaseSchankanlage.prototype.handleResponse = function (s) {
        this.app.verbose("Response Default " + s.toString());
        return true;
    };
    BaseSchankanlage.prototype.getUmsatzData = function (cb) {
        console.log("sollte nie aufgerufen werden getUmsatzData");
        cb(false);
    };
    BaseSchankanlage.prototype.sendUmsatz = function (data, cb) {
        console.log("Base Send Umsatz)");
        cb(true);
    };
    BaseSchankanlage.prototype.runLoop = function () {
        var _this = this;
        if (!this.inUse) {
            if (this.portHandler) {
                if (this.portHandler.isOpen()) {
                    if (this.OpenJobs && this.OpenJobs.length > 0) {
                        this.app.Status.OpenFromServer = this.OpenJobs.length;
                        this.inUse = true;
                        this.sendUmsatz(this.OpenJobs[0], function (res) {
                            _this.inUse = false;
                            if (res) {
                                _this.OpenJobs.shift();
                                _this.app.Status.OpenFromServer--;
                            }
                        });
                    }
                    else if (this.app.Config.CheckUmsatz) {
                        if (new Date() > this.nextCheck) {
                            this.inUse = true;
                            this.getUmsatzData(function (res) {
                                _this.inUse = false;
                                if (!res) {
                                    _this.nextCheck = new Date(new Date().getTime() + _this.app.Config.CheckTime);
                                }
                            });
                        }
                    }
                }
            }
            else {
            }
        }
        else {
        }
    };
    BaseSchankanlage.prototype.initComport = function () {
        if (this.app.Config.ComDevice) {
            if (this.app.Config.ComDevice === "sim") {
                var ax = new TcpPortHandler_1.TcpPortHandler(this.app, null, null);
                ax.startLocalServer();
                this.portHandler = ax;
            }
            else if (this.app.Config.ComDevice.length > 0) {
                this.portHandler = new ComportHandler_1.ComportHandler(this.app);
            }
        }
    };
    return BaseSchankanlage;
}());
exports.BaseSchankanlage = BaseSchankanlage;
//# sourceMappingURL=BaseSchankanlage.js.map