"use strict";
var TcpPortHandler = (function () {
    function TcpPortHandler(app, host, port) {
        this.app = app;
        this.host = host;
        this.port = port;
        this.inUse = false;
        this.Count = 1;
        if (!this.port) {
            this.port = 3011;
        }
        this.net = require("net");
        if (this.host == null) {
            this.host = "127.0.0.1";
            this.startLocalServer();
        }
    }
    TcpPortHandler.prototype.getDevice = function () {
        return this.app.Config.ComDevice;
    };
    TcpPortHandler.prototype.isOpen = function () {
        return true;
    };
    TcpPortHandler.prototype.close = function () {
        try {
            this.server.close();
        }
        catch (e) {
        }
    };
    TcpPortHandler.prototype.canUse = function () {
        return this.server != null;
    };
    TcpPortHandler.prototype.startLocalServer = function () {
        var _this = this;
        if (!this.server) {
            this.server = this.net.createServer();
            this.server.listen(this.port, this.host);
            this.app.verbose("Server listening on " + 3011);
            this.server.on("connection", function (sock) {
                _this.app.verbose("CONNECTED: " + sock.remoteAddress + ":" + sock.remotePort);
                sock.on("data", function (data) {
                    if (data.toString() === "E") {
                        if (_this.check()) {
                            var s = _this.app.SchankHandler.formatNr(10, _this.app.Config.KellnerLength);
                            s += _this.app.SchankHandler.formatNr(100, _this.app.Config.PLULength);
                            s += _this.app.SchankHandler.formatNr(1, _this.app.Config.CountLength);
                            sock.write(s);
                        }
                        else {
                            var s = _this.app.SchankHandler.formatNr(0, _this.app.Config.KellnerLength);
                            s += _this.app.SchankHandler.formatNr(0, _this.app.Config.PLULength);
                            s += _this.app.SchankHandler.formatNr(0, _this.app.Config.CountLength);
                            sock.write(s);
                        }
                    }
                    else {
                        if (_this.check()) {
                            sock.write("X");
                        }
                        else {
                            sock.write("R");
                        }
                    }
                    sock.end();
                    sock.destroy();
                });
            });
        }
    };
    TcpPortHandler.prototype.check = function () {
        this.Count--;
        if (this.Count < 1) {
            this.Count = 3;
        }
        return this.Count === 3;
    };
    TcpPortHandler.prototype.randomIntInc = function (low, high) {
        return Math.floor(Math.random() * (high - low + 1) + low);
    };
    TcpPortHandler.prototype.sendData = function (text, cb) {
        var _this = this;
        this.inUse = true;
        var client = new this.net.Socket();
        client.on("data", function (data) {
            _this.app.verbose("DATA CR: " + data);
            try {
                _this.inUse = false;
                cb(data);
            }
            catch (e) {
                _this.app.logError("TCP Client " + e);
            }
        });
        client.connect(this.port, this.host, function () {
            client.write(text);
        });
    };
    return TcpPortHandler;
}());
exports.TcpPortHandler = TcpPortHandler;
//# sourceMappingURL=TcpPortHandler.js.map