﻿var app = angular.module('dikasStart', []);

app.controller('RootCtrl', ["$scope", "$http", function ($scope, $http) {
	// org.chromium.identity OAuth für User Login auf Bring Your Own.
	// http://plugins.cordova.io/#/package/org.chromium.identity

	// Zeit die gewartet wird bis zur letzen bekannten Adresse verbunden wird. 
	var AutoConnectWaitTime = 3000; // Bei 0 ist es ausgeschaltet  2000;
	var AutoConnectTimer = null;

	$scope.ErrorMessage = "";
	$scope.TotalServers = 0;
	$scope.IsServerSearch = false;
	$scope.IsManuell = false;
	$scope.AbortButtonText = "Manuell";
	$scope.OpenServersToCheck = 0;
	$scope.IpLoaded = false
	$scope.LocalPrefix = "";
	$scope.canScan = window["cordova"] != null;

	try {
		var conf = window.localStorage.getItem("serverconfig", null);
		if (conf) {
			$scope.Config = JSON.parse(conf);
		}
	} catch (e) {
		$scope.Config = null;
	}

	// Default Config Initallisieren 
	if (!$scope.Config) {
		$scope.Config = {
			Server: '192.168.20.10',
			UseSSL: true
		}
	}

	// OK wir starten nun die Server Suche. 
	$scope.doSearch = function (cbhit) {
		$scope.IsManuell = false;
		$scope.AbortButtonText = "Abbrechen";
		$scope.IsServerSearch = true;
		$scope.ErrorMessage = "Suche Server...";

		var ip = [];

		try {
			if ($scope.Config.Server) {
				ip = $scope.Config.Server.split('.');
			}
		} catch (e) { }

		if (ip.length > 2 && ip.length < 5) {
			if (ip.length == 4) {
				ip.pop();
			}

			$scope.IpLoaded = true;
			$scope.LocalPrefix = ip.join('.') + '.';

		} else {
			$scope.IpLoaded = false;
			$scope.LocalPrefix = '';
		}

		if ($scope.IpLoaded) {
			checkAllServers(cbhit);
		} else {
			$scope.checkLokalIp(function () {
				checkAllServers(cbhit);
			});
		}
	}

	$scope.checkLokalIp = function (cb) {
		try {
			if ($scope.IpLoaded) {
				$scope.Config.Server = $scope.LocalPrefix;
				if (cb != null) {
					cb();
				}
			} else {
				try {
					getIP(cb);
				} catch (e) {
					$scope.doManuell();
					$scope.ErrorMessage = "";
					$scope.LocalPrefix = '';
				}
			}
		} catch (e) {
			$scope.ErrorMessage = "Fehler " + e;
		}
	}

	function getIP(cb) {
		// Benötigt ein Plugin
		try {
			networkinterface.getIPAddress(function (ipdata) {
				console.log("IP " + ipdata);
				var ip = ipdata.split('.');
				if (ip.length == 4) {
					// Letzes Element aus der LIste nehmen 
					ip.pop();
					$scope.IpLoaded = true;
					$scope.LocalPrefix = ip.join('.') + '.';

					if (cb != null) {
						cb($scope.LocalPrefix);
					}
				}
			});
		} catch (e) {
			console.log("Error in Network " + e);
		}
	}

	$scope.scanQR = function () {
		try {
			cordova.plugins.barcodeScanner.scan(function (result) {
				$scope.$apply(function () {
					if (result.cancelled == false) {
						$scope.Config.Server = result.text;
					}
				}),
					function (error) {
						$scope.ErrorMessage = "Probleme mit dem Scannen";
					}
			});
		} catch (e) {
			$scope.ErrorMessage = e;
		}
	}

	$scope.doManuell = function () {

		// Wenn wir auf manuell umschalten dann suchen wir mal die lokale IP
		// $scope.checkLokalIp();
		$scope.ErrorMessage = "";
		$scope.IsManuell = true;
		$scope.IsServerSearch = false;
	}

	$scope.changeSecurity = function () {
		$scope.Config.UseSSL = !$scope.Config.UseSSL;
	}

	$scope.cancelAutologin = function () {
		// alert("cascel login");
		clearTimeout(AutoConnectTimer);
	}

	$scope.doConnect = function (errocb) {
		clearTimeout(AutoConnectTimer);

		$scope.IsConnection = true;

		// Anzeigen der Meldung....
		$scope.ErrorMessage = "";

		var url = "http";
		// if ($scope.Config.UseSSL) {
		// 	url = "https";
		// }

		var targetServer = $scope.Config.Server;

		// Wenn arbeit müssen wir nix extra machen 
		if (targetServer.toLowerCase() != "arbeit") {
			// Anpassen der Server URL 
			targetServer = targetServer.split(' ').join('.').toLowerCase();

			// 2 mal machen das wir auch wirklich alle weg haben 
			targetServer = targetServer.split('..').join('.');
			targetServer = targetServer.split('..').join('.');

			if (targetServer.indexOf(".") == -1) {
				// Bsp 10 -> Verbindet mit x.x.x.10
				var ippart = parseInt(targetServer);
				if (!isNaN(ippart) && ippart > 0 && ippart < 255) {
					targetServer = $scope.LocalPrefix + ippart.toString();
				} else {
					// Ok wir wollen einen Extrenen Server immer aktivieren.
					targetServer += ".portal.dikas.de";
					$scope.Config.UseSSL = true;
				}
			}
		}

		url += "://" + targetServer;
		// Wenn der Server nicht innerhalb von 5 Sekunden geantwortet hat ist was falsch!
		$http.get(url + "/rest2/system/systemlicense", {
			timeout: 5000
		}).then(function (res) {
			var e = res.data;
			if (e.DocumentType == "SystemLicense") {
				saveConfig("https://" + targetServer);
			} else {
				$scope.IsConnection = false;
				$scope.ErrorMessage = "Kein Dikas Server";
				if (errocb) {
					errocb();
				}
			}
		}, function (err) {
			$scope.IsConnection = false;
			// OK wenn wir Probleme haben versuchen wir es ohne ssl 
			if (err.status == -1 && $scope.Config.UseSSL) {
				errorcount++;
				if (errorcount > 2) {
					$scope.Config.UseSSL = false;
				}
				$scope.doConnect();
			} else {
				if (err.status > 0) {
					$scope.ErrorMessage = "Server Fehler " + err.status;
				} else {
					$scope.ErrorMessage = "Keine Verbindung";
				}
				if (errocb) {
					errocb();
				}
			}
		});
	}

	errorcount = 1;


	$scope.performSearch = function () {
		if (!$scope.IsServerSearch) {
			$scope.IsManuell = false;
			$scope.doSearch(function (target) {
				// Wir wollen nun den User Fragen ob wie 
				$scope.IsServerSearch = false;
				$scope.IsManuell = true;
				$scope.Config.Server = target;
			});
		}
	}

	/* Server Checken wir testen immer 5 Gleichzeitig */
	var serverToCheck = [];
	var serverInCheck = 0;
	var checkIntervall;

	function checkAllServers(cbhit) {
		serverToCheck = [];
		$scope.TotalServers = 0;

		if ($scope.LocalPrefix && $scope.LocalPrefix.split('.').length > 2) {

			for (var i = 1; i < 254; i++) {
				$scope.TotalServers++;
				serverToCheck.push($scope.LocalPrefix + i.toString());
			}

			$scope.OpenServersToCheck = serverToCheck.length;

			checkIntervall = setInterval(function () {
				// So nun tragen wir immer mal 5 ein. 
				while (serverInCheck < 5 && serverToCheck.length > 0 && $scope.IsServerSearch) {
					serverInCheck++;
					checkServer2(serverToCheck.shift(), cbhit);
				}

				$scope.OpenServersToCheck = serverToCheck.length + serverInCheck;
				$scope.CurrentPercent = ((($scope.TotalServers - $scope.OpenServersToCheck) / $scope.TotalServers) * 100).toFixed(0);

				if (!$scope.$$phase) {
					$scope.$apply();
				}

				if (!$scope.IsServerSearch) {
					serverToCheck.length = 0;
					$scope.OpenServersToCheck = 0;
				}

				if ($scope.OpenServersToCheck == 0) {
					clearInterval(checkIntervall);
					$scope.ErrorMessage = "";
				}
			}, 300);
		} else {

		}
	}

	function checkServer2(ip, cbhit) {
		try {
			// Nur wenn wir in einem 192 Netz sind. 
			var url = "http://" + ip + "/rest2/system/systemlicense";

			$scope.ErrorMessage = ip;
			$http.get(url, {
				timeout: 2000
			}).success(function (res) {
				serverInCheck--;
				if (res != null) {
					try {
						// Sicherstellen das es sich um einen Lizenz Handelt 
						if (res.DocumentType == "SystemLicense") {
							$scope.IsServerSearch = false;
							$scope.IsServerSearch.IsManuell = true;
							$scope.ErrorMessage = "";
							cbhit(ip);
						}
					} catch (e) { }
				}
			}).error(function () {
				serverInCheck--;
			});
		} catch (e) {
			serverInCheck--;
		}
	}

	function saveConfig(url) {
		// OK wir wollen die Seite aufmachen. 
		try {
			window.localStorage.setItem("serverconfig", JSON.stringify($scope.Config));
		} catch (e) { }

		window.location = url + "/cp?dapp=2017.1.9";
	}

	function doAutoConnect() {
		if ($scope.Config.Server && $scope.Config.Server.length > 0) {
			$scope.ErrorMessage = "";

			if (AutoConnectWaitTime > 0) {
				// Wir geben uns einfach mal etwas zeit :-)
				AutoConnectTimer = setTimeout(function () {
					AutoConnectTimer = null;

					$scope.$apply(function () {
						// 1 Sekunde bis auto login. Damit der Kunde ggf anderen Server einstellen kann. 
						if (!$scope.IsManuell) {
							$scope.doConnect(function () {
								// Ok wir können keine Verbindungsymbols anzeigen und machen ggf wieder eine Server Suche?
								$scope.IsManuell = 1;
							});
						}
					});
				}, AutoConnectWaitTime);
			}
		}

	}

	if (window["cordova"]) {
		// Sicherstellen das wir das ausführen wenn es breit ist 
		document.addEventListener('deviceready', function () {
			$scope.$apply(function () {
				console.log("device Ready");
				// Sicherstellen das wir die IP schon mal haben 

				try {
					cordova.plugins.certificates.trustUnsecureCerts(true);
					console.log("USE SSL Test");
				} catch (e) {
					console.log("Disable Error " + e);

					onDeviceReady();
				}
			}, false);
		});

		function onDeviceReady() {

			/** Ausbleneden der Status bar*/
			try {
				StatusBar.hide();
			} catch (ex) { }

			getIP();
			doAutoConnect();
			/* Auto Start */
			// });

			// if ($scope.Config.Server) {
			// 	$scope.doConnect();
			// }
		}
	} else {
		// Windows Modus so verbinden
		doAutoConnect();
	}
}]);